#!/usr/bin/env ruby
#
# Copyright (c) 2005 by David Kamphausen. All rights reserved.
#
# ant_sheep.rb
# by David Kamphausen (david.kamphausen@web.de)
#
# The "Antargis" project, including all files needed to compile it,
# is free software; you can redistribute it and/or use it and/or modify it
# under the terms of the GNU General Public License as published
# by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# You should have received a copy of the GNU General Public
# License along with this program.
#

#!/usr/bin/ruby

def getFishMeshData
	getMeshData("data/models/fish.ant2",0.02,"data/textures/models/fish.png")
end

class AntFish<AntAnimal
	def initialize()
		super(AGVector2.new(0,0))
		setProvide("fish",true)
		setSpeed 0.6
		@lastBirth=0
		@foodAdd=0

		setOnGround(false)
		setPos(AGVector3.new(0,0,-0.3))

		puts "FISH:#{getPos3D}"
		
		mesh=Mesh.new(getMap.getScene,getFishMeshData,AGVector4.new(0,0,0),0)
		setMesh(mesh)

		resource.set("food",1)
		puts "FISH:#{getPos3D}"
	end
	def saveXML(node)
		super(node)
	end
	def loadXML(node)
		super(node)
	end
	def eventNoJob
		eventJobFinished
	end
	def eventJobFinished
		super

		if @dead
			newRestJob(30)
			if @alreadyDead
				$map.removeEntity(self)
			end
			@alreadyDead=true
	
			return
		end

		# BIRTHRATE is here:
		if @lastBirth>40 then
			# make child
			puts "A FISH IS BORN"
			fish=AntFish.new
			fish.setPos(getPos2D)
			$map.insertEntity(fish)
			getMap.endChange
			newRestJob(2)
			@lastBirth=-rand()*10
		else
			setPos(AGVector3.new(getPos2D,-0.3))
			newMoveJob(0,getTargetPos,0)
			setMeshState("go")
		end

		@foodAdd+=1
		#puts "FOOOOOD #{@foodAdd}"
		if @foodAdd>3 and resource.get("food")<10
			resource.add("food",1)
			@foodAdd=0
		end

		@lastBirth+=1
	end
	
	def getTargetPos
		puts "GettargetPos"
		p=getPos2D
		t=p
		ok=true
		# assure that sheep doesn't walk into water
		while $map.getHeight(t.x,t.y)>0 or ok do
			d=AGVector2.new(rand-0.5,rand-0.5).normalized*2
			t=p+d
			t=$map.truncPos(t)
			puts "HUPE"
			puts t
			
			puts $map.getHeight(t.x,t.y)
			ok=false
		end 
		return t
	end
	def setMeshState(s)
		#getFirstMesh.setAnimation(s)
	end
	def getName
		"Fish"
	end
end
